| Flutter Impeller |

Public Types | Public Member Functions | Static Public Member Functions | List of all members
impeller::AiksPlayground Class Reference

`#include <aiks_playground.h>`

Inheritance diagram for impeller::AiksPlayground:

## Public Types
using | AiksPlaygroundCallback = std::function< std::optional< Picture >(AiksContext &renderer)>
using | AiksDlPlaygroundCallback = std::function< sk_sp< flutter::DisplayList >()>
Public Types inherited from impeller::Playground
using | SinglePassCallback = std::function< bool(RenderPass &pass)>

## Public Member Functions
| AiksPlayground ()
| ~AiksPlayground ()
void | TearDown () override
void | SetTypographerContext (std::shared_ptr< TypographerContext > typographer_context)
bool | OpenPlaygroundHere (Picture picture)
bool | OpenPlaygroundHere (AiksPlaygroundCallback callback)
bool | OpenPlaygroundHere (const AiksDlPlaygroundCallback &callback)
bool | OpenPlaygroundHere (const sk_sp< flutter::DisplayList > &list)
Public Member Functions inherited from impeller::PlaygroundTest
| PlaygroundTest ()
virtual | ~PlaygroundTest ()
void | SetUp () override
void | TearDown () override
PlaygroundBackend | GetBackend () const
std::unique_ptr< fml::Mapping > | OpenAssetAsMapping (std::string asset_name) const override
RuntimeStage::Map | OpenAssetAsRuntimeStage (const char *asset_name) const
std::string | GetWindowTitle () const override
Public Member Functions inherited from impeller::Playground
| Playground (PlaygroundSwitches switches)
virtual | ~Playground ()
void | SetupContext (PlaygroundBackend backend, const PlaygroundSwitches &switches)
void | SetupWindow ()
void | TeardownWindow ()
bool | IsPlaygroundEnabled () const
Point | GetCursorPosition () const
ISize | GetWindowSize () const
Point | GetContentScale () const
Scalar | GetSecondsElapsed () const
| Get the amount of time elapsed from the start of the playground's execution. More...
std::shared_ptr< Context > | GetContext () const
std::shared_ptr< Context > | MakeContext () const
bool | OpenPlaygroundHere (const Renderer::RenderCallback &render_callback)
bool | OpenPlaygroundHere (SinglePassCallback pass_callback)
std::shared_ptr< Texture > | CreateTextureForFixture (const char *fixture_name, bool enable_mipmapping=false) const
std::shared_ptr< Texture > | CreateTextureCubeForFixture (std::array< const char *, 6 > fixture_names) const
fml::Status | SetCapabilities (const std::shared_ptr< Capabilities > &capabilities)
bool | WillRenderSomething () const

## Static Public Member Functions
static bool | ImGuiBegin (const char *name, bool *p_open, ImGuiWindowFlags flags)
Static Public Member Functions inherited from impeller::Playground
static bool | ShouldOpenNewPlaygrounds ()
static std::shared_ptr< CompressedImage > | LoadFixtureImageCompressed (std::shared_ptr< fml::Mapping > mapping)
static std::optional< DecompressedImage > | DecodeImageRGBA (const std::shared_ptr< CompressedImage > &compressed)
static std::shared_ptr< Texture > | CreateTextureForMapping (const std::shared_ptr< Context > &context, std::shared_ptr< fml::Mapping > mapping, bool enable_mipmapping=false)
static bool | SupportsBackend (PlaygroundBackend backend)

## Additional Inherited Members
Protected Member Functions inherited from impeller::Playground
void | SetWindowSize (ISize size)
Protected Attributes inherited from impeller::Playground
const PlaygroundSwitches | switches_

## Detailed Description

Definition at line 17 of file aiks_playground.h.

## Member Typedef Documentation

## ◆ AiksDlPlaygroundCallback

using impeller::AiksPlayground::AiksDlPlaygroundCallback = std::function<sk_sp<flutter::DisplayList>()>

Definition at line 22 of file aiks_playground.h.

## ◆ AiksPlaygroundCallback

using impeller::AiksPlayground::AiksPlaygroundCallback = std::function<std::optional<Picture>(AiksContext& renderer)>

Definition at line 20 of file aiks_playground.h.

## Constructor & Destructor Documentation

## ◆ AiksPlayground()

impeller::AiksPlayground::AiksPlayground | ( |  | ) |

Definition at line 17 of file aiks_playground.cc.

18 : typographer_context_(TypographerContextSkia::Make()) {}

## ◆ ~AiksPlayground()

impeller::AiksPlayground::~AiksPlayground | ( |  | ) |
| default

## Member Function Documentation

## ◆ ImGuiBegin()

bool impeller::AiksPlayground::ImGuiBegin | ( | const char * | name,
|  | bool * | p_open,
|  | ImGuiWindowFlags | flags
| ) |  |
| static

Definition at line 69 of file aiks_playground.cc.

71 {
72 ImGui::Begin(name, p_open, flags);
73 return true;
74 }

Referenced by impeller::testing::BlendModeTest(), and impeller::testing::TEST_P().

## ◆ OpenPlaygroundHere() [1/4]

bool impeller::AiksPlayground::OpenPlaygroundHere | ( | AiksPlaygroundCallback | callback | ) |

Definition at line 48 of file aiks_playground.cc.

48 {
49 if (!switches_.enable_playground) {
50 return true;
51 }
52
53 AiksContext renderer(GetContext(), typographer_context_);
54
55 if (!renderer.IsValid()) {
56 return false;
57 }
58
59 return Playground::OpenPlaygroundHere(
60 [&renderer, &callback](RenderTarget& render_target) -> bool {
61 std::optional<Picture> picture = callback(renderer);
62 if (!picture.has_value()) {
63 return false;
64 }
65 return renderer.Render(*picture, render_target, true);
66 });
67 }

References impeller::PlaygroundSwitches::enable_playground, impeller::Playground::GetContext(), impeller::AiksContext::IsValid(), impeller::Playground::OpenPlaygroundHere(), impeller::AiksContext::Render(), and impeller::Playground::switches_.

## ◆ OpenPlaygroundHere() [2/4]

bool impeller::AiksPlayground::OpenPlaygroundHere | ( | const AiksDlPlaygroundCallback & | callback | ) |

Definition at line 84 of file aiks_playground.cc.

85 {
86 AiksContext renderer(GetContext(), typographer_context_);
87
88 if (!renderer.IsValid()) {
89 return false;
90 }
91
92 return Playground::OpenPlaygroundHere(
93 [&renderer, &callback](RenderTarget& render_target) -> bool {
94 auto display_list = callback();
95 DlDispatcher dispatcher;
96 display_list->Dispatch(dispatcher);
97 Picture picture = dispatcher.EndRecordingAsPicture();
98
99 return renderer.Render(picture, render_target, true);
100 });
101 }

References impeller::DlDispatcherBase::EndRecordingAsPicture(), impeller::Playground::GetContext(), impeller::AiksContext::IsValid(), impeller::Playground::OpenPlaygroundHere(), and impeller::AiksContext::Render().

## ◆ OpenPlaygroundHere() [3/4]

bool impeller::AiksPlayground::OpenPlaygroundHere | ( | const sk_sp< flutter::DisplayList > & | list | ) |

Definition at line 76 of file aiks_playground.cc.

77 {
78 DlDispatcher dispatcher;
79 list->Dispatch(dispatcher);
80 Picture picture = dispatcher.EndRecordingAsPicture();
81 return OpenPlaygroundHere(std::move(picture));
82 }

References impeller::DlDispatcherBase::EndRecordingAsPicture(), and OpenPlaygroundHere().

## ◆ OpenPlaygroundHere() [4/4]

bool impeller::AiksPlayground::OpenPlaygroundHere | ( | Picture | picture | ) |

Definition at line 31 of file aiks_playground.cc.

31 {
32 if (!switches_.enable_playground) {
33 return true;
34 }
35
36 AiksContext renderer(GetContext(), typographer_context_);
37
38 if (!renderer.IsValid()) {
39 return false;
40 }
41
42 return Playground::OpenPlaygroundHere(
43 [&renderer, &picture](RenderTarget& render_target) -> bool {
44 return renderer.Render(picture, render_target, true);
45 });
46 }

References impeller::PlaygroundSwitches::enable_playground, impeller::Playground::GetContext(), impeller::AiksContext::IsValid(), impeller::Playground::OpenPlaygroundHere(), impeller::AiksContext::Render(), and impeller::Playground::switches_.

Referenced by impeller::testing::CanRenderConicalGradientWithDithering(), impeller::testing::CanRenderLinearGradientWithDithering(), impeller::testing::CanRenderRadialGradientWithDithering(), impeller::testing::CanRenderSweepGradientWithDithering(), and OpenPlaygroundHere().

## ◆ SetTypographerContext()

void impeller::AiksPlayground::SetTypographerContext | ( | std::shared_ptr< TypographerContext > | typographer_context | ) |

Definition at line 22 of file aiks_playground.cc.

23 {
24 typographer_context_ = std::move(typographer_context);
25 }

## ◆ TearDown()

void impeller::AiksPlayground::TearDown | ( |  | ) |
| override

Definition at line 27 of file aiks_playground.cc.

27 {
28 PlaygroundTest::TearDown();
29 }

References impeller::PlaygroundTest::TearDown().

The documentation for this class was generated from the following files:

- impeller/aiks/aiks_playground.h
- impeller/aiks/aiks_playground.cc

impeller::PlaygroundTest::TearDown
void TearDown() override
Definition: playground_test.cc:61
impeller::Playground::switches_
const PlaygroundSwitches switches_
Definition: playground.h:118
impeller::AiksPlayground::OpenPlaygroundHere
bool OpenPlaygroundHere(Picture picture)
Definition: aiks_playground.cc:31
impeller::Playground::OpenPlaygroundHere
bool OpenPlaygroundHere(const Renderer::RenderCallback &render_callback)
Definition: playground.cc:204
impeller::Playground::GetContext
std::shared_ptr< Context > GetContext() const
Definition: playground.cc:90
impeller::PlaygroundSwitches::enable_playground
bool enable_playground
Definition: switches.h:16
impeller::TypographerContextSkia::Make
static std::shared_ptr< TypographerContext > Make()
Definition: typographer_context_skia.cc:78